=begin
#-----------------------------------------------------------------------
作者：星野傳說
版本：1.0
名稱：線轉組件
使用方法：需選擇一個組件和線(多)或組(多))，再對話框設置要轉組件的軸向、比例、及是否刪除原有線和組。
#-----------------------------------------------------------------------
名稱: An_Line_Group_to_ComponentInstance
版本說明:	1.0 2015.01.20
            利用TIG_Lines2Components(線轉組件)改編而來。增加了軸向、比例、及原有線刪除選項。	
#-----------------------------------------------------------------------
=end
require 'sketchup.rb'
#def
def An_Line_Group_to_ComponentInstance()
  model=Sketchup.active_model  #------------------------------回傳=>模型中激活的實例
  model.start_operation("星野_線組轉組件") #--------------------模型啟動運行 插件
  entities=model.active_entities #----------------------------回傳實體=>模型中激活的實例
  sel=model.selection #---------------------------------------被選中的實例
  sela=sel.to_a  #--------------------------------------------選中實例個數
  
  #===========================================================選擇判斷
  if not sela[1] #--------------------------------------------未選取
    UI.messagebox("選擇必需包含組件和線（多）或組(多)。\n退出...")#---------------提醒對話框
    return nil   #-------------------------------------------------------強制退出插件
  end#========================================================判斷有選擇的結果
  
  ins=nil#----------------------------------------------------------------定義ins函數為空
  lines =[] #-------------------------------------------------------------定義lines函數為空
  lines1=[] #-------------------------------------------------------------定義lines1函數為空
  sela.each{ #------------------------------------------------------------分類所選每一個實例
    |e|ins=e if e.typename=="ComponentInstance"#--------------------------ComponentInstance=組件的實例
    lines.push(e) if e.typename=="Edge" #---------------------------------Edge=邊緣成列表
	lines1.push(e) if e.typename=="Group" #-------------------------------Group=組成列表
	}#====================================================================分類結束
   
  if not ins#============================================================判斷 缺少組件
    UI.messagebox("選擇必需包含組件。\n退出...")#------------------------提醒對話框
    return nil#----------------------------------------------------------強制退出插件
  end#===================================================================判斷 缺少組件結束
  
  if not lines[0] and not lines1[0]#=======================================================判斷 缺少線
    UI.messagebox("選擇必需包含線線（多）或組(多)。\n退出...")#---------------------提醒對話框
    return nil#----------------------------------------------------------強制退出插件
  end#===================================================================if結束

  #======================================================================對話框預先定義內容
  @an_gtl_z=nil ;@an_gtl_s=nil ;@an_gtl_l=nil
  an_gtl_z = Sketchup.read_default('AnLineGrouptoComponentInstance', 'an_gtl_z')#-向SU寫入定義記憶函數
  an_gtl_s = Sketchup.read_default('AnLineGrouptoComponentInstance', 'an_gtl_s')#-向SU寫入定義記憶函數
  an_gtl_l = Sketchup.read_default('AnLineGrouptoComponentInstance', 'an_gtl_l')#-向SU寫入定義記憶函數
  @an_gtl_z  = an_gtl_z.to_s  unless an_gtl_z==nil 
  an_gtl_z ="Z"        if not @an_gtl_z#---------------先讀su定義，如果an_gtl_z=空，則定義內容為：z
  @an_gtl_s  = an_gtl_s.to_s  unless an_gtl_s==nil 
  an_gtl_s ="固定比例"       if not @an_gtl_s#---------------先讀su定義，如果an_gtl_s=空，則定義內容為：是
  @an_gtl_l  = an_gtl_l.to_s  unless an_gtl_l==nil 
  an_gtl_l ="是" if not @an_gtl_l#---------------先讀su定義，如果an_gtl_l=空，則定義內容為：固定比例
  
  #======================================================================啟動對話框
  pops = ["X|Y|Z", "固定比例|依線或組", "否|是"]#------------------------對話框可選定義
  values  = [an_gtl_z, an_gtl_s, an_gtl_l]#-------------------------------預先定義
  prompts = ["主軸向：", "比例：", "刪除原有線或組："]#------------------對話框選項類別定義
  results = inputbox(prompts, values, pops, "星野_線組轉組件_設置")#-----産生對話框
  return nil unless results#---------------------------------------------對話框判斷取消強制退出，除非選擇確定。
  @an_gtl_z, @an_gtl_s, @an_gtl_l = results#-----------------------------將選擇回傳定義函數
  an_gtl_z, an_gtl_s, an_gtl_l=@an_gtl_z, @an_gtl_s, @an_gtl_l
  Sketchup.write_default('AnLineGrouptoComponentInstance', 'an_gtl_z', @an_gtl_z)#向SU寫入定義記憶內容
  Sketchup.write_default('AnLineGrouptoComponentInstance', 'an_gtl_s', @an_gtl_s)#向SU寫入定義記憶內容
  Sketchup.write_default('AnLineGrouptoComponentInstance', 'an_gtl_l', @an_gtl_l)#向SU寫入定義記憶內容
  #UI.messagebox("選擇的是"+an_gtl_z+"軸")#------------------------------測試提示對話框文字插文字函數
  #======================================================================對話框結束
  
  #======================================================================兩點轉組函數
  def an_vector_toss(ent,pt1,pt2,xyzaxis,xysca,scaxx)#ent=組件的實例，pt1=第一點，pt2=第二點，xyzaxis=軸向，xysca=y軸比例
    v2=pt1.vector_to pt2#---------------------------------------------V2回傳 第一點到第二點的向量(軸向)
	dist = pt1.distance (pt2)#----------------------------------------兩點距離
	pt = ent.transformation.origin#-----------------------------------(原點)
	t=ent.transformation#---------------------------------------------t=回傳轉化
    	if xyzaxis=="X"
        	defnht=ent.bounds.max.x-ent.bounds.min.x #------------------------defnht回傳新組件x軸最大x至最少x距離
			x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			if scaxx==1;x=1;end
			 ent.transformation=Geom::Transformation.scaling(x,xysca,xysca)*t#---轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 myx = ent.transformation.xaxis#-----------------------------------組件y軸向
			 myy = ent.transformation.yaxis#-----------------------------------組件y軸向
			 myz = ent.transformation.zaxis#-----------------------------------組件Z軸向
			 fangle = myy.angle_between(myz)#----------------------------------y軸和Z軸角度
			 ent.transform! Geom::Transformation.new(pt1,myy,-fangle)#---------以y軸為軸心旋轉
			 ent.transform! Geom::Transformation.new(pt1,myz,-fangle)#----------以y軸為軸心旋轉
			 end
			 if xyzaxis=="Y"
			 defnht=ent.bounds.max.y-ent.bounds.min.y #------------------------defnht回傳新組件x軸最大x至最少x距離
			 x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			 if scaxx==1;x=1;end
			 ent.transformation=Geom::Transformation.scaling(xysca,x,xysca)*t#-轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 myx = ent.transformation.xaxis#-----------------------------------組件x軸向
			 myy = ent.transformation.yaxis#-----------------------------------組件y軸向
			 myz = ent.transformation.zaxis#-----------------------------------組件Z軸向
			 fangle = myy.angle_between(myz)#----------------------------------y軸和Z軸角度
			 ent.transform! Geom::Transformation.new(pt1,myx,fangle)#---------以x軸為軸心旋轉
			 ent.transform! Geom::Transformation.new(pt1,myz,fangle*2)#---------以y軸為軸心旋轉
			end
			if xyzaxis=="Z"
 			 defnht=ent.bounds.max.z-ent.bounds.min.z #------------------------defnht回傳新組件x軸最大x至最少x距離
			 x=dist/defnht#----------------------------------------------------兩點距離除以組件距離
			 if scaxx==1;x=1;end
			 ent.transformation=Geom::Transformation.scaling(xysca,xysca,x)*t#---轉化組件X軸比例
			 ent.transform! Geom::Transformation.new(pt1,v2)#------------------修改向量(軸向)
			 end
		 ent
		end
  
###======================================================================迴圈線組轉組件開始
  @comp = ins#----------------------------------------------------@comp回傳為組件
  lines.each{|e| #------------------------------------------------每一個線轉組件開始
    pt1 = e.start.position#---------------------------------------回傳線起點為第一點
	pt2 = e.end.position#-----------------------------------------回傳線起點為第二點
	tr=Geom::Transformation.new([0, 0, 0])#-----------------------TR回傳 幾何圖形新的組件定義
	comp_copy=entities.add_instance(@comp.definition,tr)#---------複製添加實例
	if (dist = pt1.distance (pt2))> 0#-------------------如果兩點距離大於0
        if @an_gtl_s =="固定比例"#-----------------------如果固定比例
	     an_vector_toss(comp_copy,pt1,pt2,@an_gtl_z,1,1)#------兩點距離轉組未值為1
		else
		 an_vector_toss(comp_copy,pt1,pt2,@an_gtl_z,1,nil)#----兩點距離轉組未值為空
		end#---------------------------------------------結束
	end#-------------------------------------------------如果兩點距離大於0，線轉組結束
	if @an_gtl_l=="是"#------------------------------如果選擇"是"
	    model.active_entities.erase_entities e#---------刪除線
    end#---------------------------------------------如果選擇"是"結束
  }#-----------------------------------------------------每一個線轉組件結束
	
  lines1.each{|e| #-----------------------------------------------------------每一個組轉組件開始
    pt1 = e.transformation.origin#--------------------------------------------回傳選擇的組件(原點)為第一點
	pzs = e.bounds.max.z-e.bounds.min.z#----------------------------------組件Z軸向最小到最大的距離
	pt2=Geom::Point3d.new([pt1[0].to_inch,pt1[1].to_inch,pt1[2].to_inch+pzs])#第一點z軸向加最大距離後為第二點
	tr=Geom::Transformation.new([0, 0, 0])#----------------------------------TR回傳 幾何圖形新的組件定義
	comp_copy=entities.add_instance(@comp.definition,tr)#------------------------複製添加實例
	if @an_gtl_s =="固定比例"#------------------------------------------------如果固定比例
	    an_vector_toss(comp_copy,pt1,pt2,@an_gtl_z,1,1)#------------------------------------兩點距離轉組未值為1
	else
		an_vector_toss(comp_copy,pt1,pt2,@an_gtl_z,1,nil)#--------------------------兩點距離轉組未值為空
	end#----------------------------------------------------------------------結束
	if @an_gtl_l=="是"#-------------------------------------------------------如果選擇"是"
		model.active_entities.erase_entities e#---------------------------------刪除組
	end#----------------------------------------------------------------------如果選擇"是"結束
	}
  model.commit_operation  #模型提交操作
  return nil
end#def
###
if(not file_loaded?("An_Line_Group_to_ComponentInstance.rb"))
   UI.menu("Plugins").add_item("星野_線轉組件"){An_Line_Group_to_ComponentInstance()}
end#if
file_loaded("An_Line_Group_to_ComponentInstance.rb")





